expr ::= (Const const)
       | (Var binding)           ;; pointer to binding, not var name!
       | (Lambda var* expr)
       | (Funcall expr expr*)
       | (Opcall opname expr*)
       | (If expr expr expr)
       | (Set! var expr)
       | (Begin expr*)
       | (Let ((var expr) ...) expr)
       
Questions:

- Is (Var name) enough? We need to disambiguate environments, because
  macros can inject names with different bindings. ...Can they, though?
  -> Macros can inject names from other modules;
  -> Also:
  
     (let ((x 1))
       (let-syntax ([hack (syntax-rules ()
                            [(hack val) (+ val x)])])
         (let ((x 2))
           (hack 42))))

- So variable references must carry some distinguishing bit:
  - A reference to the environment?
    - Is this enough? Can we tell how to fetch a variable defined
      elsewhere from the environment?

    - Is this allowed?
    
       (let-syntax ([hack (let ([x 1])
                            (syntax-rules ...))])
         ...)
         
      No. ò.ó  :(

  - An aribitrary unique identifier? The environment by itself does not
    seem very useful, because access to the same var has different
    "points of view" (see below). It only serves as a unique
    distinguishing bit, but any other may serve.

    -> Maybe point directly to the binding definition. [Yes.]

- Reference to the same variable may require different fetchers depending on context.

(let ([x 1])
  x  ;; [direct access]
  (lambda (y)
    (+ x y)) ;; [captured x]
    )

- This is a problem of the treeil->c phase?
  - More or less. But we don't want to fix the "fetching strategies" at the expansion level.
  - Maybe an intermediate phase between treeil and C?


    
