(include "records.scm")
(include "utils.scm")
(include "reader.scm")
(include "treeil.scm")
(include "c.scm")

(define (compile-file infile outfile)
  (let* ((toplevel-tokens (reader-read-file infile))
         (toplevel-il (map (lambda (form)
                             (form->treeil *mod* #f form))
                           toplevel-tokens))

         (ctx (toplevel->c *mod* toplevel-il)))
    (with-output-to-file outfile
      (lambda ()
        (display "#include \"prelude.h\"\n\n")
        (emit-c 0 ctx)
        (display "\nint main() { return 0; }\n")))))

(define (main args)
  (cond ((= (length args) 3)
         (let ((argv0 (car args))
               (infile (cadr args))
               (outfile (caddr args)))
           (compile-file infile outfile)))
        (else
         (display "Usage: main.scm <infile.hel> <outfile.c>\n")
         (display "args = ") (write args) (newline))))

(main (command-line))

;;(include "test.scm")
